#!/usr/bin/perl -w
use strict;
use warnings;
use Benchmark;

my $nnumeros; #numero de numeros
my @numeros;  #guarda los valores de los numeros
my $total;          # suma que queremos obtener
my $tiempo_inicial;
my $tiempo_final;
my $tiempo;

printf "De el número de números\n";
$nnumeros =  <STDIN>;
printf "De los valores de los números\n";
for(my $i=0;$i<$nnumeros;$i++)
{
    $numeros[$i] =  <STDIN>;
}
printf "De la suma a obtener\n";
$total =  <STDIN>;

#escribir($nnumeros,@numeros,$total);

$tiempo_inicial = new Benchmark;
suma($nnumeros,@numeros,$total);
$tiempo_final = new Benchmark;
$tiempo=timediff($tiempo_final, $tiempo_inicial);

#dibujar(\@origen,\@pivote,\@destino,$numero);

print "Tiempo invertido:",timestr($tiempo),"\n";

exit;

sub suma {
    my $nnumeros=$_[0];
    my @numeros=@_[1..$nnumeros];
    my $total=$_[$nnumeros+1];
    my @solucion; #almacena el subconjunto de números tomados

#inicialmente no se toma ningún número, 
# por lo que se inicializan todos los valores a cero.
#Se utiliza una posición adicional como centinela
    for(my $i=0;$i<=$nnumeros;$i++)
    {
       $solucion[$i]=0;
    }
    do
    {
#si la suma de los números tomadas coincide con el total se escribe que es solución
        if($total==sumar($nnumeros,@numeros,@solucion))
        {
             escribirsolucion($nnumeros,@numeros,@solucion);
        } 
#Se suma uno al subconjunto actual para obtener el siguiente subconjunto de números
        @solucion=sumaruno(@solucion);
   #escribir($nnumeros+1,@solucion,0);
     } while($solucion[$nnumeros]!=1); #se acaba cuando el centinela llega a valer 1
   # escribir($nnumeros+1,@solucion,0);
}

sub escribir{
    my $nnumeros=$_[0];
    my @numeros=@_[1..$nnumeros];
    my $total=$_[$nnumeros+1];
    
    print "Número de números:  ",$nnumeros,"\n";
    print "Valores de los números: \n",@numeros,"\n";
    print "Suma a obtener: ",$total,"\n\n";
}

sub sumaruno{
    my @solucion=@_;
    my $i=0;

#se suma 1 en binario, con las valores menores a la izquierda del array
    while($solucion[$i]==1) {
         $solucion[$i]=0;
         $i++;
    }
    $solucion[$i]=1;
    return @solucion;
}

sub sumar{
    my $nnumeros=$_[0];
    my @numeros=@_[1..$nnumeros];
    my @solucion=@_[$nnumeros+1..2*$nnumeros+1];
    my $suma=0;

#se hace la suma de todos los números seleccionados en el subconjunto
    for(my $i=0;$i<$nnumeros;$i++)
    {
        if($solucion[$i]==1)
        {
            $suma+=$numeros[$i];
        }
    }
    return $suma;
}

sub escribirsolucion{
    my $nnumeros=$_[0];
    my @numeros=@_[1..$nnumeros];
    my @solucion=@_[$nnumeros+1..2*$nnumeros+1];
    
    print "Solución: ";
    for(my $i=0;$i<$nnumeros;$i++)
    {
        if($solucion[$i]==1)
        {
            print $numeros[$i]," ";
        }
     }
     print "\n";
}


